/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfacePoint_h__
#define __surface_SurfacePoint_h__

namespace fe
{

/**************************************************************************//**
	@brief SurfacePoint RecordView

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfacePoint: virtual public RecordView
{
	public:
		Functor<SpatialVector>		up;
		Functor<SpatialVector>		at;
		Functor<SpatialVector>		uvw;

				SurfacePoint(void)			{ setName("SurfacePoint"); }
virtual	void	addFunctors(void)
				{
					add(up,		FE_SPEC("spc:up",
							"Orientation up from direction"));
					add(at,		FE_USE("spc:at"));
					add(uvw,	FE_SPEC("surf:uvw",
							"Texture Coordinate"));
				}
virtual	void	initializeRecord(void)
				{
				}
};

} /* namespace */

#endif /* __surface_SurfacePoint_h__ */




